/*
 * Pad for Psemu Pro like Emulators
 *
 * By: Lamer0 <Lamer0@mediaone.net>
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/cdrom.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <linux/joystick.h>
#include <sys/types.h>
#include <string.h>



#define JS_EVENT_BUTTON         0x01    /* button pressed/released */
#define JS_EVENT_AXIS           0x02    /* joystick moved */
#define JS_EVENT_INIT           0x80    /* initial state of device */

int fd; 	/* FD for /dev/js0 */
int fd2;	/*FD for /dev/js1? */

struct js_event js; /* Event Struct for JoyStick */
struct js_event js2; /* Event Struct for JoyStick2 */

void JoyStickLoad(void);
void JoyStickLoad2(void);
void JoyStickConfLoad();

int js2_support=1;


typedef char HWND;

#include "PSEmu Plugin Defs.h"
#include "pad.h"

char *LibName = "Lamer0's JoyPadXwin";

const unsigned char version = 1; // PSEmu 1.x library
const unsigned char revision = 1;
const unsigned char build = 1;

struct js_pad {
	char js_buffer[256];
	int pad_cross;
	int pad_square;
	int pad_circle;
	int pad_triangle;
	int pad_r1;
	int pad_l1;
	int pad_r2;
	int pad_l2;
	int pad_start;
	int pad_select;
} js_pad;

	


struct js_pad2 {
	char js_buffer[256];
	int pad_cross;
	int pad_square;
	int pad_circle;
	int pad_triangle;
	int pad_r1;
	int pad_l1;
	int pad_r2;
	int pad_l2;
	int pad_start;
	int pad_select;
} js_pad2;

int PadOpened = 0;
int PadFlags = 0;

char *PSEgetLibName(void) {
    return LibName;
}

unsigned long PSEgetLibType(void) {
    return PSE_LT_PAD;
}

unsigned long PSEgetLibVersion(void) {
    return version<<16|revision<<8|build;
}

long PADinit(long flags) {
    PadFlags|=flags;
	//Load Defualts then overwrite with custom controls!
	strcpy(js_pad.js_buffer,"/dev/js0");
	strcpy(js_pad2.js_buffer,"NULL");
	js_pad.pad_cross=1;
	js_pad.pad_square=0;
	js_pad.pad_circle=2;
	js_pad.pad_triangle=3;
	js_pad.pad_r1=5;
	js_pad.pad_l1=4;
	js_pad.pad_r2=7;
	js_pad.pad_l2=6;
	js_pad.pad_start=9;
	js_pad.pad_select=8;

    JoyStickConfLoad();

    return 0;
}

long PADshutdown(void) {
    return 0;
}

long PADopen(unsigned long *Disp) {
    PadOpened = 1;
    JoyStickLoad();

	if(js2_support==1) {
   		JoyStickLoad2();
	}

    return 0;
}

long PADclose(void) {
    PadOpened = 0;
	close(fd);
	//printf("\nClosing JS Buffer Read(pad 1)\n");
	if(js2_support==1) {
		close(fd2);
		//printf("\nClosing JS Buffer Read(pad 2)\n");
	}
    return 0;
}

long PADquery(void) {
    return 3; // both pads
}

typedef struct
{
    unsigned char controllerType;
    unsigned short buttonStatus;
    unsigned char rightJoyX, rightJoyY, leftJoyX, leftJoyY;
    unsigned char moveX, moveY;
    unsigned char reserved[91];
} PadDataS;

short PressedKey;
short ReleasedKey;

long PADreadPort1(PadDataS *pad) {
    static unsigned short Stat = 0xffff;
 
    memset(&js, 0, sizeof(struct js_event));

    read(fd, &js, sizeof(struct js_event));

		
    switch(js.type) {
	case JS_EVENT_BUTTON: 
			if(js_pad.pad_cross==js.number) {
				if(js.value) {
					Stat&=~(1<<14);
				}else{ 
					Stat|=(1<<14); 
				}
			}
			
			if(js_pad.pad_square==js.number) {
				if(js.value) {
					Stat&=~(1<<15); 	
				}else{ 
					Stat|=(1<<15); 
				}
			}
	
			if(js_pad.pad_circle==js.number) {
				if(js.value) {
					Stat&=~(1<<13); 	
				}else{ 
					Stat|=(1<<13); 
				}
			}

			if(js_pad.pad_triangle==js.number) {
				if(js.value) {
					Stat&=~(1<<12); 	
				}else{ 
					Stat|=(1<<12); 
				}
			}

			if(js_pad.pad_r1==js.number) {
				if(js.value) {
					Stat&=~(1<<11); 	
				}else{ 
					Stat|=(1<<11); 
				}
			}

			if(js_pad.pad_l1==js.number) {
				if(js.value) {
					Stat&=~(1<<10); 	
				}else{ 
					Stat|=(1<<10); 
				}
			}

			if(js_pad.pad_r2==js.number) {
				if(js.value) {
					Stat&=~(1<<9); 	
				}else{ 
					Stat|=(1<<9); 
				}
			}

			if(js_pad.pad_l2==js.number) {
				if(js.value) {
					Stat&=~(1<<8); 	
				}else{ 
					Stat|=(1<<8); 
				}
			}

			if(js_pad.pad_start==js.number) {
				if(js.value) {
					Stat&=~(1<<3); 	
				}else{ 
					Stat|=(1<<3); 
				}
			}

			if(js_pad.pad_select==js.number) {
				if(js.value) {
					Stat&=~(1<<0); 	
				}else{ 
					Stat|=(1<<0); 
				}
			}

		break;

	case JS_EVENT_AXIS:
		switch(js.number) {
			case 1:
				if(js.value > 0) {
					Stat&=~(1<<6); 	
				}else if(js.value < 0)  {
					Stat&=~(1<<4); 	
				}else if(js.value == 0) {
						Stat|=~(1<<6); 	
						Stat|=~(1<<4); 	
				}
				break;

			case 0:
				if(js.value > 0) {
					Stat&=~(1<<5); 	
				}else if(js.value < 0)  {
					Stat&=~(1<<7); 	
				}else if(js.value == 0) {
						Stat|=~(1<<5); 	
						Stat|=~(1<<7); 	
				}
				break;			
		}

	break;
    }


    pad->buttonStatus = Stat;
    pad->controllerType = 4; // standard

    return 0;
}

long PADreadPort2(PadDataS *pad) {
    static unsigned short Stat = 0xffff;
	if(js2_support==1) { 

    memset(&js2, 0, sizeof(struct js_event));

    read(fd2, &js2, sizeof(struct js_event));

		
    switch(js2.type) {
	case JS_EVENT_BUTTON: 
			if(js_pad2.pad_cross==js2.number) {
				if(js2.value) {
					Stat&=~(1<<14); 	
				}else{ 
					Stat|=(1<<14); 
				}
			}
			
			if(js_pad2.pad_square==js2.number) {
				if(js2.value) {
					Stat&=~(1<<15); 	
				}else{ 
					Stat|=(1<<15); 
				}
			}
	
			if(js_pad2.pad_circle==js2.number) {
				if(js2.value) {
					Stat&=~(1<<13); 	
				}else{ 
					Stat|=(1<<13); 
				}
			}

			if(js_pad2.pad_triangle==js2.number) {
				if(js2.value) {
					Stat&=~(1<<12); 	
				}else{ 
					Stat|=(1<<12); 
				}
			}

			if(js_pad2.pad_r1==js2.number) {
				if(js2.value) {
					Stat&=~(1<<11); 	
				}else{ 
					Stat|=(1<<11); 
				}
			}

			if(js_pad2.pad_l1==js2.number) {
				//printf("\nL1 Been Pressed!");
				if(js2.value) {
					Stat&=~(1<<10); 	
				}else{ 
					Stat|=(1<<10); 
				}
			}

			if(js_pad2.pad_r2==js2.number) {
				if(js2.value) {
					Stat&=~(1<<9); 	
				}else{ 
					Stat|=(1<<9); 
				}
			}

			if(js_pad2.pad_l2==js2.number) {
				if(js2.value) {
					Stat&=~(1<<8); 	
				}else{ 
					Stat|=(1<<8); 
				}
			}

			if(js_pad2.pad_start==js2.number) {
				if(js2.value) {
					Stat&=~(1<<3); 	
				}else{ 
					Stat|=(1<<3); 
				}
			}

			if(js_pad2.pad_select==js2.number) {
				if(js2.value) {
					Stat&=~(1<<0); 	
				}else{ 
					Stat|=(1<<0); 
				}
			}

		break;

	case JS_EVENT_AXIS:
		switch(js2.number) {
			case 1:
				if(js2.value > 0) {
					Stat&=~(1<<6); 	
				}else if(js2.value < 0)  {
					Stat&=~(1<<4); 	
				}else if(js2.value == 0) {
						Stat|=~(1<<6); 	
						Stat|=~(1<<4); 	
				}
				break;

			case 0:
				if(js2.value > 0) {
					Stat&=~(1<<5); 	
				}else if(js2.value < 0)  {
					Stat&=~(1<<7); 	
				}else if(js2.value == 0) {
						Stat|=~(1<<5); 	
						Stat|=~(1<<7); 	
				}
				break;			
		}

	break;
    }
	
    pad->buttonStatus = Stat;
    pad->controllerType = 4; // standard
	}

    return 0;
}

long PADkeypressed(void) {
    return 0;
}

static int cfgexit;

GtkWidget *window1;
 GtkWidget *entry1;
 GtkWidget *entry2;

long PADconfigure(void) {
  GtkWidget *fixed1;
  GtkWidget *notebook1;
  GtkWidget *fixed4;
  GtkWidget *label10;
  GtkWidget *label11;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *button1;
  GtkWidget *button3;
  GtkWidget *button4;
  GtkWidget *button5;
  GtkWidget *button6;
  GtkWidget *button7;
  GtkWidget *button8;
  GtkWidget *button9;
  GtkWidget *button10;
  GtkWidget *button11;
  GtkWidget *vseparator1;
  GtkWidget *label7;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label14;
  GtkWidget *label15;
  GtkWidget *label6;
  GtkWidget *label4;
  GtkWidget *fixed3;
  GtkWidget *label23;
  GtkWidget *label24;
  GtkWidget *label18;
  GtkWidget *label19;
  GtkWidget *label20;
  GtkWidget *label22;
  GtkWidget *label21;
  GtkWidget *label25;
  GtkWidget *label26;
  GtkWidget *label17;
  GtkWidget *button12;
  GtkWidget *vseparator2;
  GtkWidget *button13;
  GtkWidget *button14;
  GtkWidget *button15;
  GtkWidget *button16;
  GtkWidget *button17;
  GtkWidget *button18;
  GtkWidget *button19;
  GtkWidget *button20;
  GtkWidget *button21;
  GtkWidget *label5;
  GtkWidget *fixed5;
  GtkWidget *button22;
  GtkWidget *button23;
  GtkWidget *hseparator1;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *hseparator2;
  GtkWidget *label29;
  GtkWidget *label16;



  window1 = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_position(GTK_WINDOW(window1), GTK_WIN_POS_CENTER);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "JoyPad Config");

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_container_add (GTK_CONTAINER (window1), fixed1);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_fixed_put (GTK_FIXED (fixed1), notebook1, 0, 0);
  gtk_widget_set_uposition (notebook1, 0, 0);
  gtk_widget_set_usize (notebook1, 168, 280);

  fixed4 = gtk_fixed_new ();
  gtk_widget_ref (fixed4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "fixed4", fixed4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed4);
  gtk_container_add (GTK_CONTAINER (notebook1), fixed4);

  label10 = gtk_label_new ("R1");
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_fixed_put (GTK_FIXED (fixed4), label10, 8, 104);
  gtk_widget_set_uposition (label10, 8, 104);
  gtk_widget_set_usize (label10, 42, 16);

  label11 = gtk_label_new ("L1");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_fixed_put (GTK_FIXED (fixed4), label11, 8, 128);
  gtk_widget_set_uposition (label11, 8, 128);
  gtk_widget_set_usize (label11, 42, 16);

  label12 = gtk_label_new ("R2");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_fixed_put (GTK_FIXED (fixed4), label12, 8, 152);
  gtk_widget_set_uposition (label12, 8, 152);
  gtk_widget_set_usize (label12, 42, 16);

  label13 = gtk_label_new ("L2");
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_fixed_put (GTK_FIXED (fixed4), label13, 8, 176);
  gtk_widget_set_uposition (label13, 8, 176);
  gtk_widget_set_usize (label13, 42, 16);

  button1 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_fixed_put (GTK_FIXED (fixed4), button1, 72, 8);
  gtk_widget_set_uposition (button1, 72, 8);
  gtk_widget_set_usize (button1, 64, 21);

  button3 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button3", button3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button3);
  gtk_fixed_put (GTK_FIXED (fixed4), button3, 72, 32);
  gtk_widget_set_uposition (button3, 72, 32);
  gtk_widget_set_usize (button3, 64, 21);

  button4 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button4", button4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button4);
  gtk_fixed_put (GTK_FIXED (fixed4), button4, 72, 56);
  gtk_widget_set_uposition (button4, 72, 56);
  gtk_widget_set_usize (button4, 64, 21);

  button5 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button5", button5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button5);
  gtk_fixed_put (GTK_FIXED (fixed4), button5, 72, 80);
  gtk_widget_set_uposition (button5, 72, 80);
  gtk_widget_set_usize (button5, 64, 21);

  button6 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button6", button6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button6);
  gtk_fixed_put (GTK_FIXED (fixed4), button6, 72, 104);
  gtk_widget_set_uposition (button6, 72, 104);
  gtk_widget_set_usize (button6, 64, 21);

  button7 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button7);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button7", button7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button7);
  gtk_fixed_put (GTK_FIXED (fixed4), button7, 72, 128);
  gtk_widget_set_uposition (button7, 72, 128);
  gtk_widget_set_usize (button7, 64, 21);

  button8 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button8);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button8", button8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button8);
  gtk_fixed_put (GTK_FIXED (fixed4), button8, 72, 152);
  gtk_widget_set_uposition (button8, 72, 152);
  gtk_widget_set_usize (button8, 64, 21);

  button9 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button9);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button9", button9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button9);
  gtk_fixed_put (GTK_FIXED (fixed4), button9, 72, 176);
  gtk_widget_set_uposition (button9, 72, 176);
  gtk_widget_set_usize (button9, 64, 21);

  button10 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button10);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button10", button10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button10);
  gtk_fixed_put (GTK_FIXED (fixed4), button10, 72, 200);
  gtk_widget_set_uposition (button10, 72, 200);
  gtk_widget_set_usize (button10, 64, 21);

  button11 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button11);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button11", button11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button11);
  gtk_fixed_put (GTK_FIXED (fixed4), button11, 72, 224);
  gtk_widget_set_uposition (button11, 72, 224);
  gtk_widget_set_usize (button11, 64, 21);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_fixed_put (GTK_FIXED (fixed4), vseparator1, 56, 0);
  gtk_widget_set_uposition (vseparator1, 56, 0);
  gtk_widget_set_usize (vseparator1, 16, 248);

  label7 = gtk_label_new ("Square");
  gtk_widget_ref (label7);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label7", label7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label7);
  gtk_fixed_put (GTK_FIXED (fixed4), label7, 8, 32);
  gtk_widget_set_uposition (label7, 8, 32);
  gtk_widget_set_usize (label7, 50, 16);

  label8 = gtk_label_new ("Circle");
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_fixed_put (GTK_FIXED (fixed4), label8, 8, 56);
  gtk_widget_set_uposition (label8, 8, 56);
  gtk_widget_set_usize (label8, 50, 16);

  label9 = gtk_label_new ("Triangle");
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_fixed_put (GTK_FIXED (fixed4), label9, 8, 80);
  gtk_widget_set_uposition (label9, 8, 80);
  gtk_widget_set_usize (label9, 50, 16);

  label14 = gtk_label_new ("Start");
  gtk_widget_ref (label14);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label14", label14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label14);
  gtk_fixed_put (GTK_FIXED (fixed4), label14, 8, 200);
  gtk_widget_set_uposition (label14, 8, 200);
  gtk_widget_set_usize (label14, 50, 16);

  label15 = gtk_label_new ("Select");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (fixed4), label15, 8, 224);
  gtk_widget_set_uposition (label15, 8, 224);
  gtk_widget_set_usize (label15, 50, 16);

  label6 = gtk_label_new ("Cross");
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_fixed_put (GTK_FIXED (fixed4), label6, 8, 8);
  gtk_widget_set_uposition (label6, 8, 8);
  gtk_widget_set_usize (label6, 50, 16);

  label4 = gtk_label_new ("Pad 1");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label4);

  fixed3 = gtk_fixed_new ();
  gtk_widget_ref (fixed3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "fixed3", fixed3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed3);
  gtk_container_add (GTK_CONTAINER (notebook1), fixed3);

  label23 = gtk_label_new ("R2");
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_fixed_put (GTK_FIXED (fixed3), label23, 8, 152);
  gtk_widget_set_uposition (label23, 8, 152);
  gtk_widget_set_usize (label23, 42, 16);

  label24 = gtk_label_new ("L2");
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_fixed_put (GTK_FIXED (fixed3), label24, 8, 176);
  gtk_widget_set_uposition (label24, 8, 176);
  gtk_widget_set_usize (label24, 42, 16);

  label18 = gtk_label_new ("Square");
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_fixed_put (GTK_FIXED (fixed3), label18, 8, 32);
  gtk_widget_set_uposition (label18, 8, 32);
  gtk_widget_set_usize (label18, 50, 16);

  label19 = gtk_label_new ("Circle");
  gtk_widget_ref (label19);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label19", label19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label19);
  gtk_fixed_put (GTK_FIXED (fixed3), label19, 8, 56);
  gtk_widget_set_uposition (label19, 8, 56);
  gtk_widget_set_usize (label19, 50, 16);

  label20 = gtk_label_new ("Triangle");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_fixed_put (GTK_FIXED (fixed3), label20, 8, 80);
  gtk_widget_set_uposition (label20, 8, 80);
  gtk_widget_set_usize (label20, 50, 16);

  label22 = gtk_label_new ("L1");
  gtk_widget_ref (label22);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label22", label22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label22);
  gtk_fixed_put (GTK_FIXED (fixed3), label22, 8, 128);
  gtk_widget_set_uposition (label22, 8, 128);
  gtk_widget_set_usize (label22, 42, 16);

  label21 = gtk_label_new ("R1");
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_fixed_put (GTK_FIXED (fixed3), label21, 8, 104);
  gtk_widget_set_uposition (label21, 8, 104);
  gtk_widget_set_usize (label21, 42, 16);

  label25 = gtk_label_new ("Start");
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_fixed_put (GTK_FIXED (fixed3), label25, 8, 200);
  gtk_widget_set_uposition (label25, 8, 200);
  gtk_widget_set_usize (label25, 50, 16);

  label26 = gtk_label_new ("Select");
  gtk_widget_ref (label26);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label26", label26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label26);
  gtk_fixed_put (GTK_FIXED (fixed3), label26, 8, 224);
  gtk_widget_set_uposition (label26, 8, 224);
  gtk_widget_set_usize (label26, 50, 16);

  label17 = gtk_label_new ("Cross");
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_fixed_put (GTK_FIXED (fixed3), label17, 8, 8);
  gtk_widget_set_uposition (label17, 8, 8);
  gtk_widget_set_usize (label17, 50, 16);

  button12 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button12);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button12", button12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button12);
  gtk_fixed_put (GTK_FIXED (fixed3), button12, 72, 8);
  gtk_widget_set_uposition (button12, 72, 8);
  gtk_widget_set_usize (button12, 64, 21);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator2);
  gtk_fixed_put (GTK_FIXED (fixed3), vseparator2, 56, 0);
  gtk_widget_set_uposition (vseparator2, 56, 0);
  gtk_widget_set_usize (vseparator2, 16, 256);

  button13 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button13);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button13", button13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button13);
  gtk_fixed_put (GTK_FIXED (fixed3), button13, 72, 32);
  gtk_widget_set_uposition (button13, 72, 32);
  gtk_widget_set_usize (button13, 64, 21);

  button14 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button14);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button14", button14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button14);
  gtk_fixed_put (GTK_FIXED (fixed3), button14, 72, 56);
  gtk_widget_set_uposition (button14, 72, 56);
  gtk_widget_set_usize (button14, 64, 21);

  button15 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button15);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button15", button15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button15);
  gtk_fixed_put (GTK_FIXED (fixed3), button15, 72, 80);
  gtk_widget_set_uposition (button15, 72, 80);
  gtk_widget_set_usize (button15, 64, 21);

  button16 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button16);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button16", button16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button16);
  gtk_fixed_put (GTK_FIXED (fixed3), button16, 72, 104);
  gtk_widget_set_uposition (button16, 72, 104);
  gtk_widget_set_usize (button16, 64, 21);

  button17 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button17);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button17", button17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button17);
  gtk_fixed_put (GTK_FIXED (fixed3), button17, 72, 128);
  gtk_widget_set_uposition (button17, 72, 128);
  gtk_widget_set_usize (button17, 64, 21);

  button18 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button18);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button18", button18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button18);
  gtk_fixed_put (GTK_FIXED (fixed3), button18, 72, 152);
  gtk_widget_set_uposition (button18, 72, 152);
  gtk_widget_set_usize (button18, 64, 21);

  button19 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button19);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button19", button19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button19);
  gtk_fixed_put (GTK_FIXED (fixed3), button19, 72, 176);
  gtk_widget_set_uposition (button19, 72, 176);
  gtk_widget_set_usize (button19, 64, 21);

  button20 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button20);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button20", button20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button20);
  gtk_fixed_put (GTK_FIXED (fixed3), button20, 72, 200);
  gtk_widget_set_uposition (button20, 72, 200);
  gtk_widget_set_usize (button20, 64, 21);

  button21 = gtk_button_new_with_label ("set");
  gtk_widget_ref (button21);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button21", button21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button21);
  gtk_fixed_put (GTK_FIXED (fixed3), button21, 72, 224);
  gtk_widget_set_uposition (button21, 72, 224);
  gtk_widget_set_usize (button21, 64, 21);

  label5 = gtk_label_new ("Pad 2");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label5);

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (window1), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (notebook1), fixed5);

  button22 = gtk_button_new_with_label ("Save");
  gtk_widget_ref (button22);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button22", button22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button22);
  gtk_fixed_put (GTK_FIXED (fixed5), button22, 8, 224);
  gtk_widget_set_uposition (button22, 8, 224);
  gtk_widget_set_usize (button22, 54, 21);

  button23 = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (button23);
  gtk_object_set_data_full (GTK_OBJECT (window1), "button23", button23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button23);
  gtk_fixed_put (GTK_FIXED (fixed5), button23, 104, 224);
  gtk_widget_set_uposition (button23, 104, 224);
  gtk_widget_set_usize (button23, 54, 21);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_fixed_put (GTK_FIXED (fixed5), entry1, 8, 32);
  gtk_widget_set_uposition (entry1, 8, 32);
  gtk_widget_set_usize (entry1, 120, 21);
  gtk_entry_set_text (GTK_ENTRY (entry1), "/dev/js0");

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_fixed_put (GTK_FIXED (fixed5), hseparator1, 0, 56);
  gtk_widget_set_uposition (hseparator1, 0, 56);
  gtk_widget_set_usize (hseparator1, 176, 16);

  label27 = gtk_label_new ("JoyPad 1:");
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_fixed_put (GTK_FIXED (fixed5), label27, 8, 8);
  gtk_widget_set_uposition (label27, 8, 8);
  gtk_widget_set_usize (label27, 80, 16);

  label28 = gtk_label_new ("JoyPad 2:");
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_fixed_put (GTK_FIXED (fixed5), label28, 8, 72);
  gtk_widget_set_uposition (label28, 8, 72);
  gtk_widget_set_usize (label28, 80, 16);

  entry2 = gtk_entry_new ();
  gtk_widget_ref (entry2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "entry2", entry2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry2);
  gtk_fixed_put (GTK_FIXED (fixed5), entry2, 8, 96);
  gtk_widget_set_uposition (entry2, 8, 96);
  gtk_widget_set_usize (entry2, 120, 21);
  gtk_entry_set_text (GTK_ENTRY (entry2), "NULL");

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_fixed_put (GTK_FIXED (fixed5), hseparator2, 0, 120);
  gtk_widget_set_uposition (hseparator2, 0, 120);
  gtk_widget_set_usize (hseparator2, 168, 16);

  label29 = gtk_label_new ("PCSX Plugin");
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_fixed_put (GTK_FIXED (fixed5), label29, 16, 152);
  gtk_widget_set_uposition (label29, 16, 152);
  gtk_widget_set_usize (label29, 128, 40);

  label16 = gtk_label_new ("Menu");
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label16);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_button1_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button3), "clicked",
                      GTK_SIGNAL_FUNC (on_button3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button4), "clicked",
                      GTK_SIGNAL_FUNC (on_button4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button5), "clicked",
                      GTK_SIGNAL_FUNC (on_button5_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button6), "clicked",
                      GTK_SIGNAL_FUNC (on_button6_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button7), "clicked",
                      GTK_SIGNAL_FUNC (on_button7_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button8), "clicked",
                      GTK_SIGNAL_FUNC (on_button8_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button9), "clicked",
                      GTK_SIGNAL_FUNC (on_button9_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button10), "clicked",
                      GTK_SIGNAL_FUNC (on_button10_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button11), "clicked",
                      GTK_SIGNAL_FUNC (on_button11_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button12), "clicked",
                      GTK_SIGNAL_FUNC (on_button12_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button13), "clicked",
                      GTK_SIGNAL_FUNC (on_button13_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button14), "clicked",
                      GTK_SIGNAL_FUNC (on_button14_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button15), "clicked",
                      GTK_SIGNAL_FUNC (on_button15_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button16), "clicked",
                      GTK_SIGNAL_FUNC (on_button16_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button17), "clicked",
                      GTK_SIGNAL_FUNC (on_button17_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button18), "clicked",
                      GTK_SIGNAL_FUNC (on_button18_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button19), "clicked",
                      GTK_SIGNAL_FUNC (on_button19_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button20), "clicked",
                      GTK_SIGNAL_FUNC (on_button20_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button21), "clicked",
                      GTK_SIGNAL_FUNC (on_button21_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button22), "clicked",
                      GTK_SIGNAL_FUNC (on_button22_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button23), "clicked",
                      GTK_SIGNAL_FUNC (on_button23_clicked),
                      NULL);
	
	gtk_widget_show(window1); 

    while (!cfgexit) { gtk_main_iteration(); }

   cfgexit=0;

    return 0;
}

GtkWidget *AboutDlg;

void OnAboutOk() {
    gtk_widget_hide(AboutDlg);
}

void PADabout(void) {
    GtkWidget *Label;
    GtkWidget *Ok;
    GtkWidget *Box,*BBox;
    char AboutText[255];

    sprintf (AboutText,"%s %d.%d\n",LibName, revision, build);

    AboutDlg = gtk_window_new(GTK_WINDOW_DIALOG);
    gtk_widget_set_usize(AboutDlg, 260, 80);
    gtk_window_set_title(GTK_WINDOW(AboutDlg), "JoyStick About Dialog");
    gtk_window_set_position(GTK_WINDOW(AboutDlg), GTK_WIN_POS_CENTER);
    gtk_container_set_border_width(GTK_CONTAINER(AboutDlg), 10);

    Box = gtk_vbox_new(0, 0);
    gtk_container_add(GTK_CONTAINER(AboutDlg), Box);
    gtk_widget_show(Box);

    Label = gtk_label_new(AboutText);
    gtk_box_pack_start(GTK_BOX(Box), Label, FALSE, FALSE, 0);
    gtk_widget_show(Label);

    BBox = gtk_hbutton_box_new();
    gtk_box_pack_start(GTK_BOX(Box), BBox, FALSE, FALSE, 0);
    gtk_widget_show(BBox);

    Ok = gtk_button_new_with_label("Ok");
    gtk_signal_connect(GTK_OBJECT(Ok), "clicked", GTK_SIGNAL_FUNC(OnAboutOk), NULL);
    gtk_container_add(GTK_CONTAINER(BBox), Ok);
    GTK_WIDGET_SET_FLAGS(Ok, GTK_CAN_DEFAULT);
    gtk_widget_show(Ok);

    gtk_widget_show(AboutDlg);
}

long PADtest(void) {
    return 0;
}

void JoyStickLoad() {
	if((fd = open(js_pad.js_buffer, O_NONBLOCK))==-1) {
		printf("Error: Loading JoyStick Buffer (%s)(pad 1)\n",js_pad.js_buffer);
	}
	memset(&js, 0, sizeof(struct js_event));
	//printf("JoyStick Buffer Opened(pad1)\n");
}

void JoyStickLoad2() {
	if(js2_support==1) {

		if((fd2 = open(js_pad2.js_buffer, O_NONBLOCK))==-1) {
			printf("Error: Loading JoyStick Buffer (%s)(pad 2)\n",js_pad2.js_buffer);
		}
		memset(&js2, 0, sizeof(struct js_event));
		//printf("JoyStick Buffer Opened(pad2)\n");
	}
}

void JoyStickConfLoad() {
	FILE* filer;
	char cfg[256];
	char filebuffer[256];
	char command1[256],command2[256];
	
	sprintf(cfg,"%s/.jsXwin.cfg",getenv("HOME"));
	filer=fopen(cfg,"r");
	if(filer == NULL) {
		printf("\nError: Could not find ~/.jsXwin.cfg !\n");
		printf("Exit Emulator and Setup jsXwin.cfg!\n");
		printf("or\n");
		printf("Go to Configuration->Controlers to set it up!\n");
		return;
	}

	while(fgets(filebuffer,256,filer)) {
		//printf("\n%s",filebuffer);
		sscanf(filebuffer,"%s %s",command1,command2);
	
		if(strcasecmp(command1,"joystick:")==0) {
			strcpy(js_pad.js_buffer,command2);
		}	

		if(strcasecmp(command1,"joystick2:")==0) {
			if(strcasecmp(command2,"null")==0) {
				js2_support=0;
				//printf("\nJoyStick2 (pad 2) Support OFF!\n");
			}else {
				strcpy(js_pad2.js_buffer,command2);
			}
		}		
		
		if(strcasecmp(command1,"pad_cross:")==0) {
			js_pad.pad_cross = atoi(command2);
		}

		if(strcasecmp(command1,"pad_square:")==0) {
			js_pad.pad_square = atoi(command2);
		}

		if(strcasecmp(command1,"pad_circle:")==0) {
			js_pad.pad_circle = atoi(command2);
		}
			
		if(strcasecmp(command1,"pad_triangle:")==0) {
			js_pad.pad_triangle = atoi(command2);
		}	

		if(strcasecmp(command1,"pad_r1:")==0) {
			js_pad.pad_r1 = atoi(command2);
		}	

		if(strcasecmp(command1,"pad_l1:")==0) {
			js_pad.pad_l1 = atoi(command2);
		}

		if(strcasecmp(command1,"pad_r2:")==0) {
			js_pad.pad_r2 = atoi(command2);
		}

		if(strcasecmp(command1,"pad_l2:")==0) {
			js_pad.pad_l2 = atoi(command2);
		}

		if(strcasecmp(command1,"pad_start:")==0) {
			js_pad.pad_start = atoi(command2);
		}

		if(strcasecmp(command1,"pad_select:")==0) {
			js_pad.pad_select = atoi(command2);
		}

		if(js2_support==1) {
		if(strcasecmp(command1,"pad2_cross:")==0) {
			js_pad2.pad_cross = atoi(command2);
		}

		if(strcasecmp(command1,"pad2_square:")==0) {
			js_pad2.pad_square = atoi(command2);
		}

		if(strcasecmp(command1,"pad2_circle:")==0) {
			js_pad2.pad_circle = atoi(command2);
		}
			
		if(strcasecmp(command1,"pad2_triangle:")==0) {
			js_pad2.pad_triangle = atoi(command2);
		}	

		if(strcasecmp(command1,"pad2_r1:")==0) {
			js_pad2.pad_r1 = atoi(command2);
		}	

		if(strcasecmp(command1,"pad2_l1:")==0) {
			js_pad2.pad_l1 = atoi(command2);
		}

		if(strcasecmp(command1,"pad2_r2:")==0) {
			js_pad2.pad_r2 = atoi(command2);
		}

		if(strcasecmp(command1,"pad2_l2:")==0) {
			js_pad2.pad_l2 = atoi(command2);
		}

		if(strcasecmp(command1,"pad2_start:")==0) {
			js_pad2.pad_start = atoi(command2);
		}

		if(strcasecmp(command1,"pad2_select:")==0) {
			js_pad2.pad_select = atoi(command2);
		}
		}
	}

	fclose(filer);
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_cross=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
  		
	close(fd);
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_square=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_circle=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_triangle=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_r1=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_l1=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_r2=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_l2=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_start=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad();
	for(;;) {
		memset(&js, 0, sizeof(struct js_event));

		read (fd, &js, sizeof(struct js_event));
		switch(js.type) {
			case JS_EVENT_BUTTON: 
				js_pad.pad_select=js.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd);
}

//JOYSTICK 2 STARTS HERE
void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_cross=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_square=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button14_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_circle=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button15_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_triangle=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button16_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_r1=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button17_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_l1=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button18_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_r2=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button19_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_l2=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button20_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_start=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}


void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	int flag=0;

	JoyStickLoad2();
	for(;;) {
		memset(&js2, 0, sizeof(struct js_event));

		read (fd2, &js2, sizeof(struct js_event));
		switch(js2.type) {
			case JS_EVENT_BUTTON: 
				js_pad2.pad_select=js2.number;
				flag++;
				break;

		}	

		if(flag>5) { break; }	

	}
	close(fd2);
}

void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	FILE* filer;
	char file_str[256],js_dev[256];
	char cfg[256];

	sprintf(cfg,"%s/.jsXwin.cfg",getenv("HOME"));
	filer = fopen(cfg,"w");

	
	
	fputs("//Config Made by JoyStick Configurator!\n",filer);

	strcpy(js_dev,gtk_entry_get_text(GTK_ENTRY (entry1)));
	sprintf(file_str,"joystick: %s\n",js_dev);
	fputs(file_str,filer);

	strcpy(js_dev,gtk_entry_get_text(GTK_ENTRY (entry2)));
	sprintf(file_str,"joystick2: %s\n",js_dev);
	fputs(file_str,filer);

	sprintf(file_str,"pad_cross: %i\n",js_pad.pad_cross);
	fputs(file_str,filer);
	sprintf(file_str,"pad_square: %i\n",js_pad.pad_square);
	fputs(file_str,filer);
	sprintf(file_str,"pad_circle: %i\n",js_pad.pad_circle);
	fputs(file_str,filer);
	sprintf(file_str,"pad_triangle: %i\n",js_pad.pad_triangle);
	fputs(file_str,filer);
	sprintf(file_str,"pad_r1: %i\n",js_pad.pad_r1);
	fputs(file_str,filer);
	sprintf(file_str,"pad_l1: %i\n",js_pad.pad_l1);
	fputs(file_str,filer);
	sprintf(file_str,"pad_r2: %i\n",js_pad.pad_r2);
	fputs(file_str,filer);
	sprintf(file_str,"pad_l2: %i\n",js_pad.pad_l2);
	fputs(file_str,filer);
	sprintf(file_str,"pad_start: %i\n",js_pad.pad_start);
	fputs(file_str,filer);
	sprintf(file_str,"pad_select: %i\n",js_pad.pad_select);
	fputs(file_str,filer);
	fputs("//JoyPad2\n",filer);
	sprintf(file_str,"pad2_cross: %i\n",js_pad2.pad_cross);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_square: %i\n",js_pad2.pad_square);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_circle: %i\n",js_pad2.pad_circle);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_triangle: %i\n",js_pad2.pad_triangle);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_r1: %i\n",js_pad2.pad_r1);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_l1: %i\n",js_pad2.pad_l1);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_r2: %i\n",js_pad2.pad_r2);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_l2: %i\n",js_pad2.pad_l2);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_start: %i\n",js_pad2.pad_start);
	fputs(file_str,filer);
	sprintf(file_str,"pad2_select: %i\n",js_pad2.pad_select);
	fputs(file_str,filer);

	fclose(filer);

	gtk_widget_hide(window1);
    	gtk_widget_destroy(window1);
    	cfgexit=1;
}


void
on_button23_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_hide(window1);
    gtk_widget_destroy(window1);
    cfgexit=1;
}

